Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 713)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 715)
@@ -5,21 +5,21 @@
  *
  * SOCLIB_LGPL_HEADER_BEGIN
- * 
+ *
  * This file is part of SoCLib, GNU LGPLv2.1.
- * 
+ *
  * SoCLib is free software; you can redistribute it and/or modify it
  * under the terms of the GNU Lesser General Public License as published
  * by the Free Software Foundation; version 2.1 of the License.
- * 
+ *
  * SoCLib is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * Lesser General Public License for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public
  * License along with SoCLib; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
  * 02110-1301 USA
- * 
+ *
  * SOCLIB_LGPL_HEADER_END
  */
@@ -38,17 +38,17 @@
 /////////////////////////////////////////////////////////////////////////////////
 
-#define DEBUG_DMA_CMD	    	1
-#define DEBUG_DMA_RSP	    	1
-#define DEBUG_TLB_MISS	    	1
-#define DEBUG_CONFIG_CMD		1
-#define DEBUG_CONFIG_RSP		1
-#define DEBUG_MISS_WTI_CMD  	1
-
-namespace soclib { 
+#define DEBUG_DMA_CMD           1
+#define DEBUG_DMA_RSP           1
+#define DEBUG_TLB_MISS          1
+#define DEBUG_CONFIG_CMD        1
+#define DEBUG_CONFIG_RSP        1
+#define DEBUG_MISS_WTI_CMD      1
+
+namespace soclib {
 namespace caba {
 
 namespace {
 
-const char *dma_cmd_fsm_state_str[] = 
+const char *dma_cmd_fsm_state_str[] =
     {
         "DMA_CMD_IDLE",
@@ -61,5 +61,5 @@
     };
 
-const char *dma_rsp_fsm_state_str[] = 
+const char *dma_rsp_fsm_state_str[] =
     {
         "DMA_RSP_IDLE_DMA",
@@ -71,5 +71,5 @@
     };
 
-const char *tlb_fsm_state_str[] = 
+const char *tlb_fsm_state_str[] =
     {
         "TLB_IDLE",
@@ -78,5 +78,5 @@
         "TLB_PTE1_SELECT",
         "TLB_PTE1_UPDT",
-        "TLB_PTE2_GET",                                                  
+        "TLB_PTE2_GET",
         "TLB_PTE2_SELECT",
         "TLB_PTE2_UPDT",
@@ -86,24 +86,25 @@
     };
 
-const char *config_cmd_fsm_state_str[] = 
+const char *config_cmd_fsm_state_str[] =
     {
         "CONFIG_CMD_IDLE",
-        "CONFIG_CMD_NEXT",
+        "CONFIG_CMD_HI",
+        "CONFIG_CMD_LO",
         "CONFIG_CMD_PUT",
         "CONFIG_CMD_RSP",
     };
 
-const char *config_rsp_fsm_state_str[] = 
+const char *config_rsp_fsm_state_str[] =
     {
         "CONFIG_RSP_IDLE_IOX",
         "CONFIG_RSP_IDLE_LOC",
-        "CONFIG_RSP_PUT_LOW", 
-        "CONFIG_RSP_PUT_HI", 
-        "CONFIG_RSP_PUT_UNC", 
-        "CONFIG_RSP_PUT_LOC", 
+        "CONFIG_RSP_PUT_LO",
+        "CONFIG_RSP_PUT_HI",
+        "CONFIG_RSP_PUT_UNC",
+        "CONFIG_RSP_PUT_LOC",
     };
 
-const char *miss_wti_rsp_state_str[] = 
-    {  
+const char *miss_wti_rsp_state_str[] =
+    {
         "MISS_WTI_RSP_IDLE",
         "MISS_WTI_RSP_WTI_IOX",
@@ -117,16 +118,17 @@
 ////////////////////////
 tmpl(/**/)::VciIoBridge(
-    sc_module_name 			            name,
-    const soclib::common::MappingTable 	&mt_ext,
-    const soclib::common::MappingTable 	&mt_int,
-    const soclib::common::MappingTable 	&mt_iox,
-    const soclib::common::IntTab 	    &int_tgtid,     // INT network TGTID
-    const soclib::common::IntTab 	    &int_srcid,     // INT network SRCID
-    const soclib::common::IntTab 	    &iox_tgtid,     // IOX network TGTID
+    sc_module_name                      name,
+    const soclib::common::MappingTable  &mt_ext,
+    const soclib::common::MappingTable  &mt_int,
+    const soclib::common::MappingTable  &mt_iox,
+    const soclib::common::IntTab        &int_tgtid,     // INT network TGTID
+    const soclib::common::IntTab        &int_srcid,     // INT network SRCID
+    const soclib::common::IntTab        &iox_tgtid,     // IOX network TGTID
+    const soclib::common::IntTab        &iox_srcid,     // IOX network SRCID
     const size_t                        dcache_words,
-    const size_t 				        iotlb_ways,
-    const size_t 				        iotlb_sets,
-    const uint32_t				        debug_start_cycle,
-    const bool				            debug_ok)
+    const size_t                        iotlb_ways,
+    const size_t                        iotlb_sets,
+    const uint32_t                      debug_start_cycle,
+    const bool                          debug_ok)
     : soclib::caba::BaseModule(name),
 
@@ -143,6 +145,12 @@
       // INT & IOX Network
       m_int_seglist( mt_int.getSegmentList( int_tgtid )),
-      m_int_srcid( mt_int.indexForId( int_srcid )), 
+      m_int_srcid( mt_int.indexForId( int_srcid )),
       m_iox_seglist( mt_iox.getSegmentList( iox_tgtid )),
+      m_iox_srcid( mt_iox.indexForId( iox_srcid )),
+
+      m_srcid_gid_mask( mt_int.getSrcidLevelBits()[0],  // use global bits
+                        mt_int.getSrcidLevelBits()[1]), // drop local bits
+      m_srcid_lid_mask( mt_int.getSrcidLevelBits()[1],  // use local bits
+                        0),
 
       m_iotlb_ways(iotlb_ways),
@@ -176,12 +184,12 @@
       r_dma_cmd_to_dma_rsp_rtrdid("r_dma_cmd_to_dma_rsp_rtrdid"),
       r_dma_cmd_to_dma_rsp_rpktid("r_dma_cmd_to_dma_rsp_rpktid"),
-     
+
       r_dma_cmd_to_tlb_req("r_dma_cmd_to_tlb_req"),
       r_dma_cmd_to_tlb_vaddr("r_dma_cmd_to_tlb_vaddr"),
-      
+
       //DMA_RSP FSM registers
       r_dma_rsp_fsm("r_dma_rsp_fsm"),
 
-      // CONFIG_CMD FSM registers 
+      // CONFIG_CMD FSM registers
       r_config_cmd_fsm("r_config_cmd_fsm"),
 
@@ -192,4 +200,7 @@
       r_config_cmd_to_config_rsp_rerror("r_config_cmd_to_config_rsp_rerror"),
       r_config_cmd_to_config_rsp_rdata("r_config_cmd_to_config_rsp_rdata"),
+      r_config_cmd_to_config_rsp_rsrcid("r_config_cmd_to_config_rsp_rsrcid"),
+      r_config_cmd_to_config_rsp_rtrdid("r_config_cmd_to_config_rsp_rtrdid"),
+      r_config_cmd_to_config_rsp_rpktid("r_config_cmd_to_config_rsp_rpktid"),
 
       r_config_cmd_wdata("r_config_cmd_wdata"),
@@ -198,6 +209,6 @@
       r_config_cmd_address("r_config_cmd_address"),
       r_config_cmd_srcid("r_config_cmd_srcid"),
+      r_config_cmd_trdid("r_config_cmd_trdid"),
       r_config_cmd_pktid("r_config_cmd_pktid"),
-      r_config_cmd_trdid("r_config_cmd_trdid"),
       r_config_cmd_plen("r_config_cmd_plen"),
       r_config_cmd_clen("r_config_cmd_clen"),
@@ -208,6 +219,11 @@
       r_config_cmd_eop("r_config_cmd_eop"),
 
-      // CONFIG_RSP FSM registers  
+      // ID translation table used by CONFIG_CMD and CONFIG_RSP FSMs
+      m_iox_transaction_tab(1),
+
+      // CONFIG_RSP FSM registers
       r_config_rsp_fsm("r_config_rsp_fsm"),
+      r_config_rsp_rsrcid("r_config_rsp_rsrcid"),
+      r_config_rsp_rtrdid("r_config_rsp_rtrdid"),
 
       // TLB FSM registers
@@ -217,10 +233,10 @@
       r_tlb_miss_error("r_tlb_miss_error"),
 
-      r_tlb_paddr("r_tlb_paddr"),		 
+      r_tlb_paddr("r_tlb_paddr"),
       r_tlb_pte_flags("r_tlb_pte_flags"),
       r_tlb_pte_ppn("r_tlb_pte_ppn"),
       r_tlb_way("r_tlb_way"),
-      r_tlb_set("r_tlb_set"), 
-   
+      r_tlb_set("r_tlb_set"),
+
       r_tlb_buf_valid("r_tlb_buf_valid"),
       r_tlb_buf_tag("r_tlb_buf_tag"),
@@ -231,5 +247,5 @@
 
       // MISS_WTI_RSP FSM registers
-      r_miss_wti_rsp_fsm("r_miss_wti_rsp_fsm"), 
+      r_miss_wti_rsp_fsm("r_miss_wti_rsp_fsm"),
       r_miss_wti_rsp_error_wti("r_miss_wti_rsp_error_wti"),
       r_miss_wti_rsp_error_miss("r_miss_wti_rsp_error_miss"),
@@ -244,20 +260,20 @@
       // TLB for IOMMU
       r_iotlb("iotlb", 0, iotlb_ways, iotlb_sets, vci_param_int::N),
-     
+
       // DMA_CMD FIFOs
       m_dma_cmd_addr_fifo("m_dma_cmd_addr_fifo",2),
-      m_dma_cmd_srcid_fifo("m_dma_cmd_srcid_fifo",2), 
-      m_dma_cmd_trdid_fifo("m_dma_cmd_trdid_fifo",2), 
-      m_dma_cmd_pktid_fifo("m_dma_cmd_pktid_fifo",2), 
-      m_dma_cmd_be_fifo("m_dma_cmd_be_fifo",2), 
-      m_dma_cmd_cmd_fifo("m_dma_cmd_cmd_fifo",2), 
-      m_dma_cmd_contig_fifo("m_dma_cmd_contig_fifo",2), 
-      m_dma_cmd_data_fifo("m_dma_cmd_data_fifo",2), 
+      m_dma_cmd_srcid_fifo("m_dma_cmd_srcid_fifo",2),
+      m_dma_cmd_trdid_fifo("m_dma_cmd_trdid_fifo",2),
+      m_dma_cmd_pktid_fifo("m_dma_cmd_pktid_fifo",2),
+      m_dma_cmd_be_fifo("m_dma_cmd_be_fifo",2),
+      m_dma_cmd_cmd_fifo("m_dma_cmd_cmd_fifo",2),
+      m_dma_cmd_contig_fifo("m_dma_cmd_contig_fifo",2),
+      m_dma_cmd_data_fifo("m_dma_cmd_data_fifo",2),
       m_dma_cmd_eop_fifo("m_dma_cmd_eop_fifo",2),
-      m_dma_cmd_cons_fifo("m_dma_cmd_cons_fifo",2), 
-      m_dma_cmd_plen_fifo("m_dma_cmd_plen_fifo",2), 
-      m_dma_cmd_wrap_fifo("m_dma_cmd_wrap_fifo",2), 
+      m_dma_cmd_cons_fifo("m_dma_cmd_cons_fifo",2),
+      m_dma_cmd_plen_fifo("m_dma_cmd_plen_fifo",2),
+      m_dma_cmd_wrap_fifo("m_dma_cmd_wrap_fifo",2),
       m_dma_cmd_cfixed_fifo("m_dma_cmd_cfixed_fifo",2),
-      m_dma_cmd_clen_fifo("m_dma_cmd_clen_fifo",2), 
+      m_dma_cmd_clen_fifo("m_dma_cmd_clen_fifo",2),
 
       // DMA_RSP FIFOs
@@ -268,5 +284,5 @@
       m_dma_rsp_reop_fifo("m_dma_rsp_reop_fifo",2),
       m_dma_rsp_rerror_fifo("m_dma_rsp_rerror_fifo",2),
- 
+
       // CONFIG_CMD FIFOs
       m_config_cmd_addr_fifo("m_config_cmd_addr_fifo",2),
@@ -286,5 +302,5 @@
 
       // CONFIG_RSP FIFOs
-      m_config_rsp_data_fifo("m_config_rsp_data_fifo",2),     
+      m_config_rsp_data_fifo("m_config_rsp_data_fifo",2),
       m_config_rsp_rsrcid_fifo("m_config_rsp_rsrcid_fifo",2),
       m_config_rsp_rtrdid_fifo("m_config_rsp_rtrdid_fifo",2),
@@ -311,5 +327,5 @@
     std::cout << "  - Building VciIoBridge : " << name << std::endl;
 
-    // checking segments on INT network 
+    // checking segments on INT network
     assert ( ( not m_int_seglist.empty() ) and
     "VCI_IO_BRIDGE ERROR : no segment allocated on INT network");
@@ -320,9 +336,9 @@
         std::cout << "    => segment " << int_seg->name()
                   << " / base = " << std::hex << int_seg->baseAddress()
-                  << " / size = " << int_seg->size() 
-                  << " / special = " << int_seg->special() << std::endl; 
-    }
-
-    // checking segments on IOX network 
+                  << " / size = " << int_seg->size()
+                  << " / special = " << int_seg->special() << std::endl;
+    }
+
+    // checking segments on IOX network
     assert ( ( not m_iox_seglist.empty() ) and
     "VCI_IO_BRIDGE ERROR : no segment allocated on IOX network");
@@ -333,8 +349,8 @@
         std::cout << "    => segment " << iox_seg->name()
                   << " / base = " << std::hex << iox_seg->baseAddress()
-                  << " / size = " << iox_seg->size() << std::endl; 
-    }
-
-    assert( (vci_param_int::N == vci_param_ext::N) and 
+                  << " / size = " << iox_seg->size() << std::endl;
+    }
+
+    assert( (vci_param_int::N == vci_param_ext::N) and
     "VCI_IO_BRIDGE ERROR: VCI ADDRESS widths must be equal on the 3 networks");
 
@@ -343,8 +359,8 @@
 
     assert( (vci_param_int::B == 4) and
-    "VCI_IO_BRIDGE ERROR: VCI DATA width must be 32 bits on internal network");    
+    "VCI_IO_BRIDGE ERROR: VCI DATA width must be 32 bits on internal network");
 
     assert( (vci_param_ext::B == 8) and
-    "VCI_IO_BRIDGE ERROR: VCI DATA width must be 64 bits on external network");    
+    "VCI_IO_BRIDGE ERROR: VCI DATA width must be 64 bits on external network");
 
     assert( (vci_param_int::S == vci_param_ext::S) and
@@ -357,5 +373,5 @@
     dont_initialize();
     sensitive << p_clk.pos();
-  
+
     SC_METHOD(genMoore);
     dont_initialize();
@@ -392,4 +408,10 @@
         r_iotlb.printTrace();
     }
+
+    if(mode & 0x02)
+    {
+        std::cout << "  IOX TRANSACTION TAB" << std::endl;
+        m_iox_transaction_tab.printTrace();
+    }
 }
 
@@ -398,9 +420,14 @@
 ////////////////////////
 {
-    std::cout << name() << std::endl
-        << "- IOTLB MISS RATE      = " << (float)m_cpt_iotlb_miss/m_cpt_iotlb_read << std::endl
-        << "- IOTLB MISS COST         = " << (float)m_cost_iotlb_miss/m_cpt_iotlb_miss << std::endl
-        << "- IOTLB MISS TRANSACTION COST  = " << (float)m_cost_iotlbmiss_transaction/m_cpt_iotlbmiss_transaction << std::endl
-        << "- IOTLB MISS TRANSACTION RATE (OVER ALL MISSES)  = " << (float)m_cpt_iotlbmiss_transaction/m_cpt_iotlb_miss << std::endl;
+    std::cout << name()
+        << "\n- IOTLB MISS RATE                                = "
+        << (float)m_cpt_iotlb_miss/m_cpt_iotlb_read
+        << "\n- IOTLB MISS COST                                = "
+        << (float)m_cost_iotlb_miss/m_cpt_iotlb_miss
+        << "\n- IOTLB MISS TRANSACTION COST                    = "
+        << (float)m_cost_iotlbmiss_transaction/m_cpt_iotlbmiss_transaction
+        << "\n- IOTLB MISS TRANSACTION RATE (OVER ALL MISSES)  = "
+        << (float)m_cpt_iotlbmiss_transaction/m_cpt_iotlb_miss
+        << std::endl;
 }
 
@@ -409,9 +436,9 @@
 ////////////////////////
 {
-    m_cpt_iotlb_read                = 0;             
-    m_cpt_iotlb_miss                = 0;             
+    m_cpt_iotlb_read                = 0;
+    m_cpt_iotlb_miss                = 0;
     m_cost_iotlb_miss               = 0;
-    m_cpt_iotlbmiss_transaction     = 0;    
-    m_cost_iotlbmiss_transaction    = 0;   
+    m_cpt_iotlbmiss_transaction     = 0;
+    m_cost_iotlbmiss_transaction    = 0;
 }
 
@@ -420,8 +447,12 @@
 ////////////////////////////////////
 {
-    uint32_t addr32 = (uint32_t)paddr;
-    uint32_t base   = r_xicu_base.read();
-    uint32_t size   = r_xicu_size.read();
-    return ( (addr32 >= base) and (addr32 < (base + size)) ); 
+    std::list<soclib::common::Segment>::iterator seg;
+    for ( seg  = m_iox_seglist.begin() ;
+          seg != m_iox_seglist.end()   ;
+          seg++ )
+    {
+        if ( seg->contains(paddr) ) return seg->special();
+    }
+    return false;
 }
 
@@ -430,19 +461,19 @@
 /////////////////////////
 {
-    if ( not p_resetn.read() ) 
-    {
-        r_dma_cmd_fsm	   = DMA_CMD_IDLE;
-        r_dma_rsp_fsm	   = DMA_RSP_IDLE_DMA;
-        r_tlb_fsm	       = TLB_IDLE;
+    if ( not p_resetn.read() )
+    {
+        r_dma_cmd_fsm      = DMA_CMD_IDLE;
+        r_dma_rsp_fsm      = DMA_RSP_IDLE_DMA;
+        r_tlb_fsm          = TLB_IDLE;
         r_config_cmd_fsm   = CONFIG_CMD_IDLE;
         r_config_rsp_fsm   = CONFIG_RSP_IDLE_IOX;
         r_miss_wti_rsp_fsm = MISS_WTI_RSP_IDLE;
 
-        r_tlb_buf_valid    = false; 
-		r_iommu_active     = false;
-		r_iommu_wti_enable = false;
-
-        r_xicu_size        = 0;
-        r_xicu_base        = 0;
+        r_tlb_buf_valid    = false;
+        r_iommu_active     = false;
+        r_iommu_wti_enable = false;
+
+        // initializing translation table
+        m_iox_transaction_tab.init();
 
         // initializing FIFOs
@@ -461,5 +492,5 @@
         m_dma_cmd_cfixed_fifo.init();
         m_dma_cmd_clen_fifo.init();
-        
+
         m_dma_rsp_rsrcid_fifo.init();
         m_dma_rsp_rtrdid_fifo.init();
@@ -468,5 +499,5 @@
         m_dma_rsp_rerror_fifo.init();
         m_dma_rsp_reop_fifo.init();
-        
+
         m_config_cmd_addr_fifo.init();
         m_config_cmd_srcid_fifo.init();
@@ -483,5 +514,5 @@
         m_config_cmd_cfixed_fifo.init();
         m_config_cmd_clen_fifo.init();
-        
+
         m_miss_wti_cmd_addr_fifo.init();
         m_miss_wti_cmd_srcid_fifo.init();
@@ -498,5 +529,5 @@
         m_miss_wti_cmd_cfixed_fifo.init();
         m_miss_wti_cmd_clen_fifo.init();
-        
+
         m_config_rsp_rsrcid_fifo.init();
         m_config_rsp_rtrdid_fifo.init();
@@ -505,10 +536,10 @@
         m_config_rsp_rerror_fifo.init();
         m_config_rsp_reop_fifo.init();
-        
-        // SET/RESET Communication flip-flops 
+
+        // SET/RESET Communication flip-flops
         r_dma_cmd_to_miss_wti_cmd_req  = false;
         r_dma_cmd_to_dma_rsp_req       = false;
-        r_dma_cmd_to_tlb_req		   = false;
-        r_config_cmd_to_tlb_req		   = false;
+        r_dma_cmd_to_tlb_req           = false;
+        r_config_cmd_to_tlb_req        = false;
         r_config_cmd_to_config_rsp_req = false;
         r_tlb_to_miss_wti_cmd_req      = false;
@@ -520,13 +551,13 @@
 
         // Debug variable
-		m_debug_activated	           = false;
-        
-	    // activity counters
-	    m_cpt_total_cycles             = 0;
-        m_cpt_iotlb_read               = 0;             
-        m_cpt_iotlb_miss               = 0;             
-        m_cpt_iotlbmiss_transaction    = 0;    
-        m_cost_iotlbmiss_transaction   = 0;   
-        
+        m_debug_activated              = false;
+
+        // activity counters
+        m_cpt_total_cycles             = 0;
+        m_cpt_iotlb_read               = 0;
+        m_cpt_iotlb_miss               = 0;
+        m_cpt_iotlbmiss_transaction    = 0;
+        m_cost_iotlbmiss_transaction   = 0;
+
         m_cpt_trt_dma_full             = 0;
         m_cpt_trt_dma_full_cost        = 0;
@@ -547,6 +578,7 @@
     bool            dma_cmd_fifo_put          = false;
     bool            dma_cmd_fifo_get          = p_vci_ini_ram.cmdack.read();
-    
-    bool            dma_rsp_fifo_put          = false; 
+    vci_srcid_t     dma_cmd_fifo_srcid        = 0;
+
+    bool            dma_rsp_fifo_put          = false;
     bool            dma_rsp_fifo_get          = p_vci_tgt_iox.rspack.read();
     vci_rerror_t    dma_rsp_fifo_rerror       = 0;
@@ -579,9 +611,9 @@
 
 #ifdef INSTRUMENTATION
-    m_cpt_fsm_dma_cmd	        [r_dma_cmd_fsm.read()] ++;
-    m_cpt_fsm_dma_rsp	        [r_dma_rsp_fsm.read() ] ++;
-    m_cpt_fsm_tlb        	    [r_tlb_fsm.read() ] ++;
-    m_cpt_fsm_config_cmd	    [r_config_cmd_fsm.read() ] ++;
-    m_cpt_fsm_config_rsp	    [r_config_rsp_fsm.read() ] ++;
+    m_cpt_fsm_dma_cmd           [r_dma_cmd_fsm.read()] ++;
+    m_cpt_fsm_dma_rsp           [r_dma_rsp_fsm.read() ] ++;
+    m_cpt_fsm_tlb               [r_tlb_fsm.read() ] ++;
+    m_cpt_fsm_config_cmd        [r_config_cmd_fsm.read() ] ++;
+    m_cpt_fsm_config_rsp        [r_config_rsp_fsm.read() ] ++;
     m_cpt_fsm_miss_wti_rsp      [r_miss_wti_rsp_fsm.read() ] ++;
 #endif
@@ -607,5 +639,5 @@
     ///////////////////////////////////////////////////////////////////////////////
 
-    switch( r_dma_cmd_fsm.read() ) 
+    switch( r_dma_cmd_fsm.read() )
     {
     //////////////////
@@ -614,7 +646,7 @@
                         // no VCI flit is consumed in this state
     {
-        if ( p_vci_tgt_iox.cmdval.read() ) 
-        { 
-            if ( not r_iommu_active.read() ) 	// tlb not activated 
+        if ( p_vci_tgt_iox.cmdval.read() )
+        {
+            if ( not r_iommu_active.read() )    // tlb not activated
             {
                 // save paddr address
@@ -625,5 +657,5 @@
                 if ( is_wti( p_vci_tgt_iox.address.read() ) )
                 {
-                    assert( p_vci_tgt_iox.eop.read() and 
+                    assert( p_vci_tgt_iox.eop.read() and
                     "ERROR in VCI_IOB illegal VCI WTI command from IOX network");
 
@@ -637,5 +669,6 @@
 #if DEBUG_DMA_CMD
 if( m_debug_activated )
-std::cout << "  <IOB DMA_CMD_IDLE> DMA command"
+std::cout << name()
+          << "  <IOB DMA_CMD_IDLE> DMA command"
           << " : address = " << std::hex << p_vci_tgt_iox.address.read()
           << " / srcid = " << p_vci_tgt_iox.srcid.read()
@@ -646,12 +679,12 @@
             }
             else if (r_tlb_fsm.read() == TLB_IDLE ||
-                     r_tlb_fsm.read() == TLB_WAIT )	  // tlb access possible
-            {
-                vci_addr_t	iotlb_paddr;
-                pte_info_t  iotlb_flags; 
-                size_t      iotlb_way;  
+                     r_tlb_fsm.read() == TLB_WAIT )   // tlb access possible
+            {
+                vci_addr_t  iotlb_paddr;
+                pte_info_t  iotlb_flags;
+                size_t      iotlb_way;
                 size_t      iotlb_set;
                 vci_addr_t  iotlb_nline;
-                bool		iotlb_hit;  
+                bool        iotlb_hit;
 
 #ifdef INSTRUMENTATION
@@ -662,17 +695,17 @@
                                               &iotlb_flags,
                                               &iotlb_nline,  // unused
-                                              &iotlb_way,	 // unused
+                                              &iotlb_way,    // unused
                                               &iotlb_set );  // unused
-            
-                if ( iotlb_hit )	                             // tlb hit
-                { 
-                    if ( not iotlb_flags.w and    // access right violation 
-                        (p_vci_tgt_iox.cmd.read() == vci_param_ext::CMD_WRITE) ) 
+
+                if ( iotlb_hit )                                 // tlb hit
+                {
+                    if ( not iotlb_flags.w and    // access right violation
+                        (p_vci_tgt_iox.cmd.read() == vci_param_ext::CMD_WRITE) )
                     {
                         // register error
-                        r_iommu_etr      = MMU_WRITE_ACCES_VIOLATION;  
+                        r_iommu_etr      = MMU_WRITE_ACCES_VIOLATION;
                         r_iommu_bvar     = p_vci_tgt_iox.address.read();
                         r_iommu_bad_id   = p_vci_tgt_iox.srcid.read();
-                        
+
                         // prepare response error request to DMA_RSP FSM
                         r_dma_cmd_to_dma_rsp_rsrcid = p_vci_tgt_iox.srcid.read();
@@ -684,5 +717,6 @@
 #if DEBUG_DMA_CMD
 if( m_debug_activated )
-std::cout << "  <IOB DMA_CMD_IDLE> TLB HIT but writable violation" << std::endl;
+std::cout << name()
+          << "  <IOB DMA_CMD_IDLE> TLB HIT but writable violation" << std::endl;
 #endif
                     }
@@ -691,5 +725,6 @@
 #if DEBUG_DMA_CMD
 if( m_debug_activated )
-std::cout << "  <IOB DMA_CMD_IDLE> TLB HIT" << std::endl;
+std::cout << name()
+          << "  <IOB DMA_CMD_IDLE> TLB HIT" << std::endl;
 #endif
                         // save paddr address
@@ -699,9 +734,9 @@
                         if ( is_wti( iotlb_paddr ) )
                         {
-                            assert( p_vci_tgt_iox.eop.read() and 
+                            assert( p_vci_tgt_iox.eop.read() and
                                    (p_vci_tgt_iox.cmd == vci_param_int::CMD_WRITE) and
                             "ERROR in VCI_IOB illegal VCI WTI command from IOX network");
 
-                            r_dma_cmd_fsm   = DMA_CMD_WTI_IOX_REQ; 
+                            r_dma_cmd_fsm = DMA_CMD_WTI_IOX_REQ;
                         }
                         else
@@ -717,13 +752,14 @@
 m_cpt_iotlb_miss++;
 #endif
-                    // register virtual address, and send request to TLB FSM 
-		            r_dma_cmd_to_tlb_vaddr = p_vci_tgt_iox.address.read();
+                    // register virtual address, and send request to TLB FSM
+                    r_dma_cmd_to_tlb_vaddr = p_vci_tgt_iox.address.read();
                     r_dma_cmd_to_tlb_req   = true;
                     r_dma_cmd_fsm          = DMA_CMD_TLB_MISS_WAIT;
 #if DEBUG_DMA_CMD
 if( m_debug_activated )
-std::cout << "  <IOB DMA_CMD_IDLE> TLB MISS" << std::endl;
-#endif
-                } // end tlb miss 
+std::cout << name()
+          << "  <IOB DMA_CMD_IDLE> TLB MISS" << std::endl;
+#endif
+                } // end tlb miss
             } // end if tlb_activated
         } // end if cmdval
@@ -732,22 +768,35 @@
     /////////////////////
     case DMA_CMD_DMA_REQ:    // put a flit in DMA_CMD FIFO
-                             // if contig, VCI address must be incremented 
+                             // if contig, VCI address must be incremented
                              // after initial translation by IOMMU.
                              // flit is consumed if DMA_CMD FIFO not full
     {
-        if ( p_vci_tgt_iox.cmdval && m_dma_cmd_addr_fifo.wok() ) 
-        {
-            dma_cmd_fifo_put = true;
-            
-            if ( p_vci_tgt_iox.contig.read() ) r_dma_cmd_paddr = r_dma_cmd_paddr.read() + 
-                                                          vci_param_ext::B;
-
-            if ( p_vci_tgt_iox.eop.read() )    r_dma_cmd_fsm   = DMA_CMD_IDLE;
-           
+        if ( p_vci_tgt_iox.cmdval && m_dma_cmd_addr_fifo.wok() )
+        {
+            // SRCID in RAM network is the concatenation of the IO bridge
+            // cluster id with the DMA peripheral local id
+            assert((m_srcid_gid_mask[p_vci_tgt_iox.srcid.read()] == 0) &&
+                    "error: external DMA peripherals global id must be 0");
+
+            dma_cmd_fifo_srcid = (m_srcid_gid_mask.mask() & m_int_srcid) |
+                                 p_vci_tgt_iox.srcid.read();
+            dma_cmd_fifo_put   = true;
+
+            if ( p_vci_tgt_iox.contig.read() )
+            {
+                r_dma_cmd_paddr = r_dma_cmd_paddr.read() + vci_param_ext::B;
+            }
+
+            if ( p_vci_tgt_iox.eop.read() )
+            {
+                r_dma_cmd_fsm = DMA_CMD_IDLE;
+            }
+
 #if DEBUG_DMA_CMD
-if( m_debug_activated ) 
-std::cout << "  <IOB DMA_CMD_FIFO_PUT_CMD> Push into DMA_CMD fifo:" 
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB DMA_CMD_FIFO_PUT_CMD> Push into DMA_CMD fifo:"
           << " address = " << std::hex << r_dma_cmd_paddr.read()
-          << " srcid = " << p_vci_tgt_iox.srcid.read()
+          << " srcid = " << dma_cmd_fifo_srcid
           << " wdata = " << p_vci_tgt_iox.wdata.read()
           << " plen = " << std::dec << p_vci_tgt_iox.plen.read()
@@ -758,26 +807,35 @@
     }
     /////////////////////////
-    case DMA_CMD_WTI_IOX_REQ:    // post a WTI_IOX request to MISS_WTI FSM 
+    case DMA_CMD_WTI_IOX_REQ:    // post a WTI_IOX request to MISS_WTI FSM
                                  // if no prending previous request
-                                 // command arguments are stored in dedicated registers 
+                                 // command arguments are stored in dedicated registers
                                  // VCI flit is consumed if no previous request
     {
         if ( not r_dma_cmd_to_miss_wti_cmd_req.read() )  // no previous pending request
         {
+            // SRCID in INT network for WTI transactions is the concatenation
+            // of the IO bridge cluster id with the DMA peripheral local id
+            assert((m_srcid_gid_mask[p_vci_tgt_iox.srcid.read()] == 0) &&
+                    "error: external DMA peripherals global id must be 0");
+
+            vci_srcid_t wti_srcid = (m_srcid_gid_mask.mask() & m_int_srcid) | 
+                                    p_vci_tgt_iox.srcid.read();
+
             r_dma_cmd_to_miss_wti_cmd_req   = true;
             r_dma_cmd_to_miss_wti_cmd_addr  = p_vci_tgt_iox.address.read();
             r_dma_cmd_to_miss_wti_cmd_cmd   = p_vci_tgt_iox.cmd.read();
             r_dma_cmd_to_miss_wti_cmd_wdata = (uint32_t)p_vci_tgt_iox.wdata.read();
-            r_dma_cmd_to_miss_wti_cmd_srcid = p_vci_tgt_iox.srcid.read();
+            r_dma_cmd_to_miss_wti_cmd_srcid = wti_srcid;
             r_dma_cmd_to_miss_wti_cmd_trdid = p_vci_tgt_iox.trdid.read();
             r_dma_cmd_to_miss_wti_cmd_pktid = PKTID_WTI_IOX;
 
             r_dma_cmd_fsm = DMA_CMD_IDLE;
-           
+
 #if DEBUG_DMA_CMD
-if( m_debug_activated ) 
-std::cout << "  <IOB DMA_CMD_WTI_IOX_REQ> request WTI transaction from ext peripheral"
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB DMA_CMD_WTI_IOX_REQ> request WTI transaction from ext peripheral"
           << " : address = " << std::hex << r_dma_cmd_paddr.read()
-          << " / srcid = " << p_vci_tgt_iox.srcid.read()
+          << " / srcid = " << wti_srcid
           << " / wdata = " << p_vci_tgt_iox.wdata.read() << std::endl;
 #endif
@@ -786,5 +844,5 @@
     }
     //////////////////////////
-    case DMA_CMD_ERR_WAIT_EOP:	 // wait EOP before requesting WTI & error response
+    case DMA_CMD_ERR_WAIT_EOP:   // wait EOP before requesting WTI & error response
                                  // VCI flit is always consumed
     {
@@ -792,15 +850,16 @@
 
 #if DEBUG_DMA_CMD
-if( m_debug_activated ) 
-std::cout << "  <IOB DMA_CMD_WAIT_EOP> wait EOP for faulty DMA command" << std::endl;
-#endif
-        break;
-    }
-    
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB DMA_CMD_WAIT_EOP> wait EOP for faulty DMA command" << std::endl;
+#endif
+        break;
+    }
+
     /////////////////////////
-    case DMA_CMD_ERR_WTI_REQ:	 // post a WTI_MMU request to MISS_WTI_CMD FSM
+    case DMA_CMD_ERR_WTI_REQ:    // post a WTI_MMU request to MISS_WTI_CMD FSM
                                  // if no prending previous request
                                  // response arguments are stored in dedicated registers
-                                 // no VCI flit is consumed 
+                                 // no VCI flit is consumed
     {
         if ( not r_dma_cmd_to_miss_wti_cmd_req.read() )  // no pending previous request
@@ -817,6 +876,7 @@
 
 #if DEBUG_DMA_CMD
-if( m_debug_activated ) 
-std::cout << "  <IOB DMA_CMD_ERR_WTI_REQ> request an IOMMU WTI" << std::endl;
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB DMA_CMD_ERR_WTI_REQ> request an IOMMU WTI" << std::endl;
 #endif
         }
@@ -827,5 +887,5 @@
                                  // if no prending previous request
                                  // response arguments are stored in dedicated registers
-                                 // no VCI flit is consumed 
+                                 // no VCI flit is consumed
     {
         if ( not r_dma_cmd_to_dma_rsp_req.read() )  // no pending previous request
@@ -839,5 +899,5 @@
     ///////////////////////////
     case DMA_CMD_TLB_MISS_WAIT:  // waiting completion of a TLB miss
-                                 // we must test a possible page fault error...   
+                                 // we must test a possible page fault error...
     {
         if ( not r_dma_cmd_to_tlb_req.read() ) // TLB miss completed
@@ -845,5 +905,5 @@
             if ( r_tlb_miss_error.read() )   // Error reported by TLB FSM
             {
-                r_iommu_etr     = MMU_READ_PT2_UNMAPPED; 
+                r_iommu_etr     = MMU_READ_PT2_UNMAPPED;
                 r_iommu_bvar    = r_dma_cmd_to_tlb_vaddr.read();
                 r_iommu_bad_id  = p_vci_tgt_iox.srcid.read();
@@ -872,9 +932,9 @@
     if ( m_dma_rsp_rerror_fifo.wok() )
     {
-        switch( r_dma_rsp_fsm.read() ) 
+        switch( r_dma_rsp_fsm.read() )
         {
             //////////////////////
             case DMA_RSP_IDLE_DMA:  // normal DMA response has highest priority
-            {    	
+            {
                 if     (p_vci_ini_ram.rspval.read())          r_dma_rsp_fsm = DMA_RSP_PUT_DMA;
                 else if(r_miss_wti_rsp_to_dma_rsp_req.read()) r_dma_rsp_fsm = DMA_RSP_PUT_WTI;
@@ -884,6 +944,6 @@
             //////////////////////
             case DMA_RSP_IDLE_WTI:  // normal WTI response has highest priority
-            {    	
-                if     (r_miss_wti_rsp_to_dma_rsp_req.read()) r_dma_rsp_fsm = DMA_RSP_PUT_WTI; 
+            {
+                if     (r_miss_wti_rsp_to_dma_rsp_req.read()) r_dma_rsp_fsm = DMA_RSP_PUT_WTI;
                 else if(r_dma_cmd_to_dma_rsp_req.read())      r_dma_rsp_fsm = DMA_RSP_PUT_ERR;
                 else if(p_vci_ini_ram.rspval.read())          r_dma_rsp_fsm = DMA_RSP_PUT_DMA;
